<?php

include("mysql.php");

$regenuser          = true;

function writeligne($ligne) {
    echo $ligne."\n";

}

function purge($table) {
    global $bddnine01;

    writeligne("$table");
    $q="DELETE FROM $table";
    $query=$bddnine01->prepare($q);
    $query->execute(); 
}

function findicon($icon) {
    global $bddnine01;

    $q="SELECT * FROM icon WHERE label=?";
    $query=$bddnine01->prepare($q);
    $query->execute([$icon]); 
    if($row=$query->fetch())
        return $row["id"];
    
    return null;
}

function matchicon($imgid) {
    global $bddeportail01;

    $q="SELECT * FROM env_icon WHERE icon_id=?";
    $query=$bddeportail01->prepare($q);
    $query->execute([$imgid]); 
    if($row=$query->fetch()) {
        switch($row["icon_url"]) {
            case "00-envole107.png" : return findicon("uploads/icon/icon_crossroads.png"); break;
            case "00-taskfreak.png" : return findicon("uploads/icon/icon_gear.png"); break;
            case "00-envole027.png" : return findicon("uploads/icon/icon_stack.png"); break;
            case "00-envole007.png" : return findicon("uploads/icon/icon_calendar.png"); break;
            case "00-envole006.png" : return findicon("uploads/icon/icon_calendar.png"); break;
            case "00-ethercalc.png" : return findicon("uploads/icon/icon_browser.png"); break;
            case "00-envole050.png" : return findicon("uploads/icon/icon_clipboard.png"); break;
            case "00-envole029.png" : return findicon("uploads/icon/icon_check.png"); break;
            case "00-opensondage.png" : return findicon("uploads/icon/icon_clipboard.png"); break;
            case "00-envole002.jpg" : return findicon("uploads/icon/icon_traffic.png"); break;
            case "00-envole004.png" : return findicon("uploads/icon/icon_booklet.png"); break;
            case "00-envole093.png" : return findicon("uploads/icon/icon_star.png"); break;
            case "00-envole154.png" : return findicon("uploads/icon/icon_microphone.png"); break;
            case "00-phpldapadmin.png" : return findicon("uploads/icon/icon_users.png"); break;
            case "00-envole129.png" : return findicon("uploads/icon/icon_brightness.png"); break;
            case "00-url.jpg" : return findicon("uploads/icon/icon_globe.png"); break;
        }
    }

    return null;
}

// Test de la connexion à la base
try{
    global $bdd01;
    $pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
    $pdo_options[PDO::MYSQL_ATTR_INIT_COMMAND] = "SET NAMES utf8";
    $bdddraaf01 = new PDO("mysql:host=".$dbhost.";dbname=draaf",$dblogin,$dbpassword,$pdo_options);
}
catch (Exception $e){
    echo "Erreur connection bdd";
    die();
}

// Test de la connexion à la base
try{
    global $bdd01;
    $pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
    $pdo_options[PDO::MYSQL_ATTR_INIT_COMMAND] = "SET NAMES utf8";
    $bddnine01 = new PDO("mysql:host=".$dbhost.";dbname=ninegate",$dblogin,$dbpassword,$pdo_options);
}
catch (Exception $e){
    echo "Erreur connection bdd";
    die();
}

// Test de la connexion à la base
try{
    global $bdd01;
    $pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
    $pdo_options[PDO::MYSQL_ATTR_INIT_COMMAND] = "SET NAMES utf8";
    $bddeportail01 = new PDO("mysql:host=".$dbhost.";dbname=eportail",$dblogin,$dbpassword,$pdo_options);
}
catch (Exception $e){
    echo "Erreur connection bdd";
    die();
}

writeligne("");
writeligne("MIGRATION");

writeligne("");
writeligne("Purge des Tables Ninegate");

Purge("alertgroupe");
Purge("alert");
Purge("alertcategory");

Purge("blogarticle");
Purge("bloggroupe");
Purge("blogwriter");
Purge("blog");

Purge("bookmark");

Purge("calendareventgroupe");
Purge("calendarevent");

Purge("calendargroupe");
Purge("calendar");

Purge("fluxgroupe");
Purge("flux");

Purge("itemniveau01");
Purge("itemgroupe");
Purge("item");
Purge("itemcategory");


Purge("noticeuser");
Purge("notice");
Purge("slide");

Purge("pagewidget");
Purge("pagegroupe");
Purge("page");

if($regenuser) {
    Purge("usergroupe");
    Purge("usermodo");

    Purge("registration");
    Purge("user");
    Purge("niveau02");
    Purge("niveau01");
    
    Purge("groupe");    
}




if($regenuser) {

    writeligne("");
    writeligne("Récupération Liste Blanche");
    $q="SELECT * FROM whitelist";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        writeligne($row["label"]);
        $q="INSERT IGNORE INTO whitelist (id, label) VALUES (?,?)";
        $query=$bddnine01->prepare($q);
        $query->execute([$row["id"],$row["label"]]);     
    }
    
    
    writeligne("");
    writeligne("Récupération Niveau 01");
    $q="SELECT * FROM service";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        writeligne($row["label"]);
        $q="INSERT IGNORE INTO niveau01 (id, label, siren,showsubappname) VALUES (?,?,?,?)";
        $query=$bddnine01->prepare($q);
        $showsubappname=($row["label"]!="Autres");
        $query->execute([$row["id"],$row["label"],$row["siren"],$showsubappname]);     
    }

    writeligne("");
    writeligne("Récupération Niveau 02");
    $q="SELECT * FROM establishment";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        writeligne($row["label"]);
        $q="INSERT IGNORE INTO niveau02 (id, label, siret, postaladress, niveau01_id) VALUES (?,?,?,?,?)";
        $query=$bddnine01->prepare($q);
        $query->execute([$row["id"],$row["label"],$row["siret"],$row["postaladress"],$row["service_id"]]);     
    }


    writeligne("");
    writeligne("Récupération Groupe");
    $q="SELECT * FROM groupe";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        writeligne($row["label"]);
        $q="INSERT IGNORE INTO groupe (id, label, fgopen, fgall, fgcancreatepage, fgcancreateblog, fgcancreatecalendar, fgtemplate, fgcanshare) VALUES (?,?,?,?,?,?,?,?,?)";
        $query=$bddnine01->prepare($q);
        if($row["fgall"])
            $query->execute([$row["id"],$row["label"],$row["fgopen"],$row["fgall"],1,1,1,0,0]);     
        else
            $query->execute([$row["id"],$row["label"],$row["fgopen"],$row["fgall"],0,0,0,0,0]);     
    }

    writeligne("");
    writeligne("Récupération User");
    $q="SELECT * FROM user";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        // copy de l'avatar
        if($row["avatar"]!="noavatar.png") {
            if(file_exists("/root/migration/backup/draaf/web/uploads/avatar/".$row["avatar"]))
                copy("/root/migration/backup/draaf/web/uploads/avatar/".$row["avatar"],"/var/www/html/ninegate/web/uploads/avatar/".$row["avatar"]);
            else
                $row["avatar"]="noavatar.png";
        }

        writeligne($row["username"]);
        $q="INSERT IGNORE INTO user (id,birthcountry_id,birthplace_id,niveau01_id,niveau02_id,username,firstname,lastname,email,visible,role,authlevel,siren,siret,usualname,telephonenumber,postaladress,givensname,birthdate,gender,job,position,keyexpire,keyvalue,belongingpopulation,avatar,password,salt) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
        $query=$bddnine01->prepare($q);
        $row["email"]=$row["id"]."@noreplay.fr";
        $query->execute([$row["id"],$row["birthcountry_id"],$row["birthplace_id"],$row["service_id"],$row["establishment_id"],$row["username"],$row["firstname"],$row["lastname"],$row["email"],$row["visible"],$row["role"],$row["authlevel"],$row["siren"],$row["siret"],$row["usualname"],$row["telephonenumber"],$row["postaladress"],$row["givensname"],$row["birthdate"],$row["gender"],$row["job"],$row["position"],$row["keyexpire"],$row["keyvalue"],$row["belongingpopulation"],$row["avatar"],$row["password"],"salt"]);     
    }

    writeligne("");
    writeligne("Récupération User Groupe");
    $q="SELECT * FROM usergroupe";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        $q="INSERT IGNORE INTO usergroupe (id, user_id, group_id) VALUES (?,?,?)";
        $query=$bddnine01->prepare($q);
        $query->execute([$row["id"],$row["user_id"],$row["group_id"]]);     
    }

    writeligne("");
    writeligne("Récupération User Modo");
    $q="SELECT * FROM usermodo";
    $querydraaf=$bdddraaf01->prepare($q);
    $querydraaf->execute(); 
    while($row=$querydraaf->fetch()) {
        $q="INSERT IGNORE INTO usermodo (id, user_id, niveau01_id) VALUES (?,?,?)";
        $query=$bddnine01->prepare($q);
        $query->execute([$row["id"],$row["user_id"],$row["service_id"]]);     
    }     
}

/*
writeligne("");
writeligne("Récupération Item Category");
$q="SELECT * FROM env_application_categorie";
$queryeportail=$bddeportail01->prepare($q);
$queryeportail->execute(); 
while($row=$queryeportail->fetch()) {
    writeligne($row["application_categorie_label"]);
    $q="INSERT INTO itemcategory (id, label, roworder) VALUES (?,?,?)";
    $query=$bddnine01->prepare($q);
    $query->execute([$row["application_categorie_id"],$row["application_categorie_label"],$row["application_categorie_order"]]);     
}  

writeligne("");
writeligne("Récupération Item");
$q="SELECT * FROM env_application";
$queryeportail=$bddeportail01->prepare($q);
$queryeportail->execute(); 
while($row=$queryeportail->fetch()) {
    // On bypasse les items liés à eportail
    $url=urldecode($row["application_url"]);
    if(strpos($url,"/eportail")!==false) continue;
    if(strpos($url,"/genconfig")!==false) continue;
    if(strpos($url,"4200/connect/")!==false) continue;
    
    //index.php?view=user/calendar.php&idcalsel=1
    writeligne($row["application_label"]." = ".$url);
 
    switch($row["application_open"]) {
        case 0 : $target="frame"; break;
        case 1 : $target="_blank"; break;
        default: $target="_blank"; break;
    }

    $q="INSERT INTO item (id, category, title, subtitle, url, target, content, rowOrder, protected,color,icon_id) VALUES (?,?,?,?,?,?,?,?,?,?,?)";
    $query=$bddnine01->prepare($q);
    $query->execute([$row["application_id"],$row["application_categorie"],$row["application_label"],null,$url,$target,$row["application_description"],$row["application_order"],false,$row["application_color"],matchicon($row["application_icon"])]);     
}  

writeligne("");
writeligne("Rattachement Item Role");
$q="SELECT * FROM env_application_profil WHERE application_profil_profil=1";
$queryeportail=$bddeportail01->prepare($q);
$queryeportail->execute(); 
while($row=$queryeportail->fetch()) {
    $q="UPDATE item SET roles=? WHERE item.id=?";
    $query=$bddnine01->prepare($q);
    $query->execute(['a:1:{i:0;s:10:"ROLE_ADMIN";}',$row["application_profil_application"]]);     
}

writeligne("");
writeligne("Rattachement Item Niveau01");
$q="SELECT * FROM env_group, env_application_group WHERE group_name LIKE ('SERVICE = %') AND group_id=application_group_group";
$queryeportail=$bddeportail01->prepare($q);
$queryeportail->execute(); 
while($row=$queryeportail->fetch()) {
    // Recherche de l'item
    $q="SELECT * FROM item WHERE id=?";
    $querynine=$bddnine01->prepare($q);
    $querynine->execute([$row["application_group_application"]]);
    if($rownine=$querynine->fetch()) {
        // Recherche du niveau01 DRAAF
        $niveau01=str_replace("SERVICE = ","",$row["group_name"]);
        $q="SELECT * FROM niveau01 WHERE label=?";
        $querynine=$bddnine01->prepare($q);
        $querynine->execute([$niveau01]);

        if($rownine=$querynine->fetch()) {
            $q="INSERT INTO itemniveau01 (item, niveau01) VALUES (?,?)";
            $query=$bddnine01->prepare($q);
            $query->execute([$row["application_group_application"],$rownine["id"]]);     
        }
    }
}


writeligne("");
writeligne("Rattachement Item Group");
$q="SELECT * FROM env_group, env_application_group WHERE group_name LIKE ('GROUPE = %') AND group_id=application_group_group";
$queryeportail=$bddeportail01->prepare($q);
$queryeportail->execute(); 
while($row=$queryeportail->fetch()) {
    // Recherche de l'item
    $q="SELECT * FROM item WHERE id=?";
    $querynine=$bddnine01->prepare($q);
    $querynine->execute([$row["application_group_application"]]);
    if($rownine=$querynine->fetch()) {    
        // Recherche du niveau01 DRAAF
        $niveau01=str_replace("GROUPE = ","",$row["group_name"]);
        $q="SELECT * FROM groupe WHERE label=?";
        $querynine=$bddnine01->prepare($q);
        $querynine->execute([$niveau01]);

        if($rownine=$querynine->fetch()) {
            writeligne($rownine["label"]." ".$row["application_group_application"]);
            $q="INSERT INTO itemgroupe (item, groupe) VALUES (?,?)";
            $query=$bddnine01->prepare($q);
            $query->execute([$row["application_group_application"],$rownine["id"]]);     
        }
    }
}
*/

